<?php 
	function list_hooks( $hook = '' ) {
		global $wp_filter;

		$hooks = isset( $wp_filter[$hook] ) ? $wp_filter[$hook] : array();  
		$hooks = call_user_func_array( 'array_merge', $hooks );

		foreach( $hooks as &$item ) {
			// function name as string or static class method eg. 'Foo::Bar'
			if ( is_string( $item['function'] ) ) { 
				$ref = strpos( $item['function'], '::' ) ? new ReflectionClass( strstr( $item['function'], '::', true ) ) : new ReflectionFunction( $item['function'] );
				$item['file'] = $ref->getFileName();
				$item['line'] = get_class( $ref ) == 'ReflectionFunction' 
					? $ref->getStartLine() 
					: $ref->getMethod( substr( $item['function'], strpos( $item['function'], '::' ) + 2 ) )->getStartLine();

			// array( object, method ), array( string object, method ), array( string object, string 'parent::method' )
			} elseif ( is_array( $item['function'] ) ) {

				$ref = new ReflectionClass( $item['function'][0] );

				// $item['function'][0] is a reference to existing object
				$item['function'] = array(
					is_object( $item['function'][0] ) ? get_class( $item['function'][0] ) : $item['function'][0],
					$item['function'][1]
				);
				$item['file'] = $ref->getFileName();
				$item['line'] = strpos( $item['function'][1], '::' )
					? $ref->getParentClass()->getMethod( substr( $item['function'][1], strpos( $item['function'][1], '::' ) + 2 ) )->getStartLine()
					: $ref->getMethod( $item['function'][1] )->getStartLine();

			// closures
			} elseif ( is_callable( $item['function'] ) ) {     
				$ref = new ReflectionFunction( $item['function'] );         
				$item['function'] = get_class( $item['function'] );
				$item['file'] = $ref->getFileName();
				$item['line'] = $ref->getStartLine();

			}       
		}
		
		echo "<pre>";
		print_r($hooks);
		echo "</pre>";
		//return $hooks;
	}

	function list_enqueue() {
		global $wp_scripts, $wp_styles;
        $scripts = $wp_scripts->registered;
		echo "<h3>Scripts</h3>";
        foreach ( $scripts as $script ) {
			echo $script->handle . ' | ';
        }
		echo "<h3>Styles</h3>";
		$styles = $wp_styles->registered;
		foreach ($styles as $style) {
			echo $style -> handle . ' | ';
		}
	}
?>